unit POP3ClientUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mKennwortfeld, StdCtrls, mTextbereich, mKnopf, mTextfeld,
  mEtikett, mSum, mTextwerkzeug, mVerbindung, mDListe;
const
  CRLF=#$D#$A;
type
  TFormularPOP3Client = class(TForm)
    hatEtikettServer: TEtikett;
    hatEtikettName: TEtikett;
    hatTextfeldName: TTextfeld;
    hatKnopfAnmelden: TKnopf;
    hatEtikettKennwort: TEtikett;
    hatEtikettFehler: TEtikett;
    hatTextfeldNachrichtNummer: TTextfeld;
    hatEtikettNachricht: TEtikett;
    hatEtikettvon: TEtikett;
    hatKnopfMailHolen: TKnopf;
    hatKnopfVorigeMail: TKnopf;
    hatKnopfNaechsteMail: TKnopf;
    hatEtikettEMail: TEtikett;
    hatTextbereichEMailAnzeige: TTextbereich;
    hatKnopfAbmelden: TKnopf;
    hatKnopfBeenden: TKnopf;
    hatKennwortfeld: TKennwortfeld;
    hatTextfeldAdresse: TTextfeld;
    hatEtikettNachrichtAnzahl: TEtikett;
    procedure FormCreate(Sender: TObject);
    procedure hatKnopfAnmeldenGeklickt(Sender: TObject);
    procedure hatKnopfBeendenGeklickt(Sender: TObject);
    procedure hatKnopfMailHolenGeklickt(Sender: TObject);
    procedure hatKnopfVorigeMailGeklickt(Sender: TObject);
    procedure hatKnopfNaechsteMailGeklickt(Sender: TObject);
    procedure hatKnopfAbmeldenGeklickt(Sender: TObject);
  private
    { Private declarations }
    hatTextwerkzeug:Textwerkzeug;
    hatVerbindung:Verbindung;
    zMailNummer:ganzeZahl;
    zAnzahl:ganzeZahl;
    function bestaetigungsNachrichtOK(pFehlermeldung:Zeichenkette):Wahrheitswert;
    procedure ladeMail(pMailNummer:ganzeZahl);
  public
    { Public declarations }
  end;

var
  FormularPOP3Client: TFormularPOP3Client;

implementation

{$R *.dfm}

 procedure TFormularPOP3Client.FormCreate(Sender: TObject);
 begin
   hatTextWerkzeug:=Textwerkzeug.init;
 end;

 function TFormularPOP3CLient.bestaetigungsNachrichtOK(pFehlermeldung:Zeichenkette):Wahrheitswert;
 var
   lBestaetigungsNachricht:Zeichenkette;
   lOK:Wahrheitswert;
 begin
   lBestaetigungsNachricht:=hatVerbindung.empfangeneNachricht;
   lOK:=hatTextWerkzeug.positionVon(lBestaetigungsNachricht,'+OK')=1;
   if lOK then
     hatEtikettFehler.setzeInhalt('')
   else
     hatEtikettFehler.setzeInhalt('Fehler: '+pFehlermeldung);
   result:=lOK
 end;

  procedure TFormularPOP3Client.ladeMail(pMailNummer:ganzeZahl);
  var
    lZeile:Zeichenkette;
  begin
    zMailNummer:=pMailNummer;
    hatTextfeldNachrichtNummer.setzeInhalt(pMailNummer);
    hatVerbindung.sende('RETR '+hatTextwerkzeug.alsText(pMailNummer));
    if self.bestaetigungsNachrichtOK('E-Mail '+hatTextWerkzeug.alsText(pMailNummer)+' nicht vorhanden.') then  begin
      hatTextbereichEMailAnzeige.setzeInhalt('');
      repeat
        lZeile:=hatVerbindung.empfangeneNachricht;
        if not hatTextwerkzeug.istGleich(lZeile,'.') then
          hatTextbereichEMailAnzeige.haengeZeichenAn(lZeile+CRLF)
      until hatTextwerkzeug.istGleich(lZeile,'.');
    end
  end;

  

procedure TFormularPOP3Client.hatKnopfAnmeldenGeklickt(Sender: TObject);
var
  lStatistik:Zeichenkette;
begin
  hatVerbindung:=Verbindung.init(hatTextfeldAdresse.inhaltAlsText,110,true);
  if self.bestaetigungsNachrichtOK('Verbindung mit '+hatTextfeldAdresse.inhaltAlsText+' nicht erfolgreich') then
  begin
    hatVerbindung.sende('USER '+hatTextfeldName.inhaltAlsText);
    if self.bestaetigungsNachrichtOK('Benutzer '+hatTextfeldName.inhaltAlsText+' existiert nicht') then
    begin
      hatVerbindung.sende('PASS '+hatKennwortfeld.inhaltAlsText);
      if self.bestaetigungsNachrichtOK('Falsches Kennwort') then begin
         hatVerbindung.sende('STAT');
         lStatistik:=hatVerbindung.empfangeneNachricht;
         zAnzahl:=hatTextwerkzeug.alsGanzeZahl(hatTextwerkzeug.wortAn(lStatistik,2));
         hatEtikettnachrichtAnzahl.setzeInhalt(zAnzahl);
         if (zAnzahl>0) then
           self.ladeMail(1)
         else
           zMailNummer:=0
      end
    end
  end
end;

procedure TFormularPOP3Client.hatKnopfMailHolenGeklickt(Sender: TObject);
var
  lNummer:ganzeZahl;
begin
  if hatTextfeldNachrichtNummer.InhaltIstGanzeZahl then begin
     lNummer:=hatTextfeldNachrichtNummer.inhaltAlsGanzeZahl;
     if (lNummer>0) and (lNummer=zAnzahl) then
       self.ladeMail(lNummer);
  end;
end;

procedure TFormularPOP3Client.hatKnopfVorigeMailGeklickt(Sender: TObject);
begin
 if zMailNummer>1 then
   self.ladeMail(zMailNummer-1);
end;

procedure TFormularPOP3Client.hatKnopfNaechsteMailGeklickt(Sender: TObject);
begin
  if zMailNummerzAnzahl then
   self.ladeMail(zMailNummer+1);
end;

procedure TFormularPOP3Client.hatKnopfAbmeldenGeklickt(Sender: TObject);
begin
  hatVerbindung.sende('QUIT');
  if self.bestaetigungsNachrichtOK('Abmelden vom Server nicht akzeptiert') then
  begin
    hatVerbindung.gibFrei;
    hatVerbindung:=nil;
  end;
end;

end.

