unit mDListe;

interface

type
  Knoten=class(TObject)
  private
    zInhalt:TObject;
    kenntNachfolger, kenntVorgaenger:Knoten;
  public
    constructor init(pInhalt:TObject;pVorgaenger, pNachfolger:Knoten);
    function inhalt:TObject;
    function vorgaenger:Knoten;
    function nachfolger:Knoten;
    function hatNachfolger:boolean;
    function hatVorgaenger:boolean;
    procedure setzeInhalt(pInhalt:TObject);
    procedure setzeVorgaenger(pVorgaenger:Knoten);
    procedure setzeNachfolger(pNachfolger:Knoten);
    destructor gibFrei;
  end;

  DListe=class(TObject)
  private
    zAnfang, zAktuelles, zAnker:Knoten;
    zLaenge:integer;
  public
    constructor init;
    procedure fuegeDavorEin(pInhalt:TObject);
    procedure fuegeDahinterEin(pInhalt:TObject);
    procedure ersetzeAktuelles(pInhalt:TObject);
    procedure entferneAktuelles;
    procedure vor;
    procedure zurueck;
    procedure zumAnfang;
    procedure zumEnde;
    function aktuelles:tobject;
    function istLeer:boolean;
    function istDavor:boolean;
    function istDahinter:boolean;
    function laenge:integer;
    destructor gibFrei;
    end;


implementation

  constructor Knoten.init(pInhalt:TObject;pVorgaenger, pNachfolger:Knoten);
  begin
    zInhalt:=pInhalt;
    kenntNachfolger:=pNachfolger;
    kenntVorgaenger:=pVorgaenger;
  end;

  function Knoten.inhalt:TObject;
  begin
    result:=zInhalt;
  end;

  function Knoten.nachfolger:Knoten;
  begin
    result:=kenntNachfolger;
  end;

  function Knoten.vorgaenger:Knoten;
  begin
    result:=kenntVorgaenger;
  end;

  function Knoten.hatNachfolger:boolean;
  begin
    result:=kenntNachfolger<>nil;
  end;

  function Knoten.hatVorgaenger:boolean;
  begin
    result:=kenntVorgaenger<>nil;
  end;

  procedure Knoten.setzeInhalt(pInhalt:TObject);
  begin
    zInhalt:=pInhalt;
  end;

  procedure Knoten.setzeNachfolger(pNachfolger:Knoten);
  begin
    kenntNachfolger:=pNachfolger;
  end;

  procedure Knoten.setzeVorgaenger(pVorgaenger:Knoten);
  begin
    kenntVorgaenger:=pVorgaenger;
  end;


  destructor Knoten.gibFrei;
  begin
  end;

  constructor DListe.init;
  begin
    zAnker:=Knoten.init(nil,nil,nil);
    zAnfang:=zAnker;
    zAktuelles:=zAnker;
  end;

  procedure DListe.fuegeDavorEin(pInhalt:TObject);
  var
    lNeuElement:Knoten;
  begin
    if not self.istDavor then
    begin
     if zAktuelles=zAnfang then begin
        lNeuElement:=Knoten.init(pInhalt,nil,zAktuelles);
        zAnfang:=lNeuElement;
        zAktuelles.setzeVorgaenger(lNeuElement);
     end else begin
           lNeuElement:=Knoten.init(pInhalt,zAktuelles.vorgaenger,zAktuelles);
           zAktuelles.setzeVorgaenger(lNeuelement);
           zAktuelles.vorgaenger.setzeNachfolger(lNeuelement);
          end;
     inc(zLaenge);
    end;
  end;

   procedure DListe.fuegeDahinterEin(pInhalt:TObject);
   var
    lNeuElement:Knoten;
   begin
    if not self.istDahinter then
    begin
     if istDavor then begin
        lNeuElement:=Knoten.init(pInhalt,nil,zAnfang);
        zAnfang.setzeVorgaenger(lNeuElement);
        zAktuelles:=lNeuelement;
        zAnfang:=zAktuelles;
     end else begin
           lNeuElement:=Knoten.init(pInhalt,zAktuelles,zAktuelles.nachfolger);
           zAktuelles.nachfolger.setzeVorgaenger(lNeuelement);
           zAktuelles.setzeNachfolger(lNeuelement);
          end;
     inc(zLaenge);
    end;
  end;

  procedure DListe.ersetzeAktuelles(pInhalt:TObject);
  begin
    if not (istDavor or istDahinter) then
      zAktuelles.setzeInhalt(pInhalt)
  end;

  procedure DListe.entferneAktuelles;
  var
    lZeiger:Knoten;
  begin
    if not (istDavor or istDahinter) then begin
      if zAktuelles=zAnfang then
        zAnfang:=zAnfang.nachfolger
      else begin
        zAktuelles.vorgaenger.setzeNachfolger(zAktuelles.nachfolger);
        zAktuelles.nachfolger.setzeVorgaenger(zAktuelles.vorgaenger);
      end;
      lZeiger:=zAktuelles;
      zAktuelles:=zAktuelles.nachfolger;
      dec(zLaenge);
      lZeiger.destroy;
    end
  end;

  procedure DListe.vor;
  begin
    if not istDahinter then
      if istDavor then
        zAktuelles:=zAnfang
      else
        zAktuelles:=zAktuelles.nachfolger
  end;

  procedure DListe.zurueck;
  begin
    if not istDavor then
      zAktuelles:=zAktuelles.vorgaenger
  end;

  procedure DListe.zumAnfang;
  begin
    if self.istLeer then
      zAktuelles:=nil
    else
      zAktuelles:=zAnfang
  end;

  procedure DListe.zumEnde;
  begin
    if self.istLeer then
      zAktuelles:=nil
    else
      zAktuelles:=zAnker.vorgaenger;
  end;

  function DListe.aktuelles:tobject;
  begin
    if self.istDavor or self.istDahinter then
      result:=nil
    else
      result:=zAktuelles.inhalt;
  end;

  function DListe.istLeer:boolean;
  begin
    result:=zLaenge=0
  end;


  function DListe.istDavor:boolean;
  begin
    result:=zAktuelles=nil
  end;

  function DListe.istDahinter:boolean;
  begin
    result:=zAktuelles=zAnker
  end;

  function DListe.laenge:integer;
  begin
    result:=zLaenge;
  end;

  destructor DListe.gibFrei;
  begin
    zumAnfang;
    while not self.istLeer do
      entferneAktuelles;
    zAnker.destroy;
  end;


end.
