unit mListe2;

interface

type
  Knoten=class(TObject)
  private
    kenntInhalt:TObject;
    kenntNachfolger, kenntVorgaenger:Knoten;
  public
    constructor init(pInhalt:TObject;pVorgaenger, pNachfolger:Knoten);
    function inhalt:TObject;
    function vorgaenger:Knoten;
    function nachfolger:Knoten;
    function hatNachfolger:boolean;
    function hatVorgaenger:boolean;
    procedure setzeInhalt(pInhalt:TObject);
    procedure setzeVorgaenger(pVorgaenger:Knoten);
    procedure setzeNachfolger(pNachfolger:Knoten);
    destructor gibFrei;
  end;

  Liste=class(TObject)
  private
    hatAnfang, hatAktuelles, hatAnker:Knoten;
    zLaenge:integer;
  public
    constructor init;
    procedure fuegeDavorEin(pInhalt:TObject);
    procedure fuegeDahinterEin(pInhalt:TObject);
    procedure haengeAn(pInhalt:TObject);
    procedure ersetzeAktuelles(pInhalt:TObject);
    procedure entferneAktuelles;
    procedure vor;
    procedure zurueck;
    procedure zumAnfang;
    procedure zumEnde;
    function aktuelles:tobject;
    function istLeer:boolean;
    function istDavor:boolean;
    function istDahinter:boolean;
    function laenge:integer;
    destructor gibFrei;
    end;


implementation

  constructor Knoten.init(pInhalt:TObject;pVorgaenger, pNachfolger:Knoten);
  begin
    kenntInhalt:=pInhalt;
    kenntNachfolger:=pNachfolger;
    kenntVorgaenger:=pVorgaenger;
  end;

  function Knoten.inhalt:TObject;
  begin
    result:=kenntInhalt;
  end;

  function Knoten.nachfolger:Knoten;
  begin
    result:=kenntNachfolger;
  end;

  function Knoten.vorgaenger:Knoten;
  begin
    result:=kenntVorgaenger;
  end;

  function Knoten.hatNachfolger:boolean;
  begin
    result:=kenntNachfolger<>nil;
  end;

  function Knoten.hatVorgaenger:boolean;
  begin
    result:=kenntVorgaenger<>nil;
  end;

  procedure Knoten.setzeInhalt(pInhalt:TObject);
  begin
    kenntInhalt:=pInhalt;
  end;

  procedure Knoten.setzeNachfolger(pNachfolger:Knoten);
  begin
    kenntNachfolger:=pNachfolger;
  end;

  procedure Knoten.setzeVorgaenger(pVorgaenger:Knoten);
  begin
    kenntVorgaenger:=pVorgaenger;
  end;


  destructor Knoten.gibFrei;
  begin
  end;

  constructor Liste.init;
  begin
    hatAnker:=Knoten.init(nil,nil,nil);
    hatAnfang:=hatAnker;
    hatAktuelles:=hatAnker;
  end;

  procedure Liste.fuegeDavorEin(pInhalt:TObject);
   var
    lNeuKnoten:Knoten;
   begin
    if self.istDahinter then
    begin
      lNeuKnoten:=Knoten.init(pInhalt,hatAnker.vorgaenger,hatAnker);
      if self.istLeer then
        hatAnfang:=lNeuKnoten
      else
          hatAnker.vorgaenger.setzeNachfolger(lNeuKnoten);
      hatAnker.setzeVorgaenger(lNeuKnoten);
     end else
           if self.istDavor then begin
             lNeuKnoten:=Knoten.init(pInhalt,nil,hatAnfang);
             hatAnfang.setzeVorgaenger(lNeuKnoten);
             hatAnfang:=lNeuknoten;
           end else begin
                  lNeuKnoten:=Knoten.init(pInhalt,hatAktuelles.vorgaenger,hatAktuelles);
                  if hatAktuelles<>hatAnfang then
                    hatAktuelles.vorgaenger.setzeNachfolger(lNeuKnoten);
                  hatAktuelles.setzeVorgaenger(lNeuKnoten)
                end;
     inc(zLaenge);
  end;

   procedure Liste.fuegeDahinterEin(pInhalt:TObject);
   var
    lNeuKnoten:Knoten;
   begin
    if self.istDahinter then
    begin
      lNeuKnoten:=Knoten.init(pInhalt,hatAnker.vorgaenger,hatAnker);
      if self.istLeer then
        hatAnfang:=lNeuKnoten
      else
          hatAnker.vorgaenger.setzeNachfolger(lNeuKnoten);
          hatAnker.setzeVorgaenger(lNeuKnoten);
     end else
           if self.istDavor then begin
             lNeuKnoten:=Knoten.init(pInhalt,nil,hatAnfang);
             if self.istLeer then
               hatAnker.setzeVorgaenger(lNeuKnoten)
             else
               hatAnfang.setzeVorgaenger(lNeuKnoten);
               hatAnfang:=lNeuknoten;
           end else begin
                  lNeuKnoten:=Knoten.init(pInhalt,hatAktuelles,hatAktuelles.nachfolger);
                  hatAktuelles.nachfolger.setzeVorgaenger(lNeuKnoten);
                  hatAktuelles.setzeNachfolger(lNeuKnoten);
                end;
     inc(zLaenge);
  end;

  procedure Liste.haengeAn(pInhalt:TObject);
  begin
    self.zumEnde;
    self.fuegeDahinterEin(pInhalt);
  end;

  procedure Liste.ersetzeAktuelles(pInhalt:TObject);
  begin
    if not (istDavor or istDahinter) then
      hatAktuelles.setzeInhalt(pInhalt)
  end;

  procedure Liste.entferneAktuelles;
  var
    lZeiger:Knoten;
  begin
    if not (istDavor or istDahinter) then begin
      if hatAktuelles=hatAnfang then
        hatAnfang:=hatAnfang.nachfolger
      else begin
        hatAktuelles.vorgaenger.setzeNachfolger(hatAktuelles.nachfolger);
        hatAktuelles.nachfolger.setzeVorgaenger(hatAktuelles.vorgaenger);
      end;
      lZeiger:=hatAktuelles;
      hatAktuelles:=hatAktuelles.nachfolger;
      lZeiger.destroy;
      dec(zLaenge);
    end
  end;

  procedure Liste.vor;
  begin
    if not istDahinter then
      if istDavor then
        hatAktuelles:=hatAnfang
      else
        hatAktuelles:=hatAktuelles.nachfolger
  end;

  procedure Liste.zurueck;
  begin
    if not istDavor then
      hatAktuelles:=hatAktuelles.vorgaenger
  end;

  procedure Liste.zumAnfang;
  begin
    if self.istLeer then
      hatAktuelles:=hatAnker
    else
      hatAktuelles:=hatAnfang
  end;

  procedure Liste.zumEnde;
  begin
    if self.istLeer then
      hatAktuelles:=nil
    else
      hatAktuelles:=hatAnker.vorgaenger;
  end;

  function Liste.aktuelles:tobject;
  begin
    if self.istDavor or self.istDahinter then
      result:=nil
    else
      result:=hatAktuelles.inhalt;
  end;

  function Liste.istLeer:boolean;
  begin
    result:=zLaenge=0
  end;


  function Liste.istDavor:boolean;
  begin
    result:=(hatAktuelles=nil);
  end;

  function Liste.istDahinter:boolean;
  begin
    result:=(hatAktuelles=hatAnker);
  end;

  function Liste.laenge:integer;
  begin
    result:=zLaenge;
  end;

  destructor Liste.gibFrei;
  begin
    self.zumAnfang;
    while not self.istLeer do
      self.entferneAktuelles;
    hatAnker.destroy;
  end;


end.
