 unit mSuchbaum;
interface
uses
  mSuM, mBinaerbaum,mListe, mOrdnungsklasse;
type
 Suchbaum = class (Binaerbaum)
               private
                 hatListe: Liste;
                 function  sucheRekursiv(pBaum:Suchbaum;pObjekt:Ordnungsklasse):Suchbaum;
                 procedure fuegeEinRekursiv(pSuchbaum:Suchbaum;pInhalt:Ordnungsklasse);
                 procedure entferneRekursiv(pBaum:Binaerbaum;pObjekt:Ordnungsklasse;mitInhalt:Wahrheitswert);
                 procedure erzeugeListe(pSuchbaum:Suchbaum);
               public
                 constructor init;
                 procedure   ueberschreibeWurzel(pInhalt:TObject);override;
                 procedure   fuegeEin(pInhalt:Ordnungsklasse);
                 function    suche(pObjekt:Ordnungsklasse):Ordnungsklasse;
                 procedure   entferne(pObjekt:Ordnungsklasse);
                 function    sortierteListe:Liste;
                 destructor  gibFrei(mitInhalt:Wahrheitswert);override;
              end;

implementation


  constructor Suchbaum.init;
  begin
    hatListe:=nil;
    inherited init;
  end;

   procedure Suchbaum.ueberschreibeWurzel(pInhalt:TObject);
   begin
     if self.istLeer then begin
       kenntLinkenNachfolger:=Suchbaum.init;
       kenntRechtenNachfolger:=Suchbaum.init;
     end;
     hatInhalt:=pInhalt;
   end;


  procedure Suchbaum.fuegeEin(pInhalt:Ordnungsklasse);
  begin
    self.fuegeEinRekursiv(self,pInhalt);
  end;

  procedure Suchbaum.fuegeEinRekursiv(pSuchbaum:Suchbaum;pInhalt:Ordnungsklasse);
  var
    lRechterTeilbaum,lLinkerTeilbaum:Suchbaum;
  begin
    if pSuchbaum.istLeer then
      pSuchbaum.ueberschreibeWurzel(pInhalt)
    else
      if pInhalt.istKleiner(Ordnungsklasse(pSuchbaum.wurzelInhalt)) then begin
         lLinkerTeilbaum:=Suchbaum(pSuchbaum.linkerTeilbaum);
         self.fuegeEinRekursiv(lLinkerTeilbaum,pInhalt);
         pSuchbaum.haengeLinksAn(lLinkerTeilbaum);
      end else
        if pInhalt.istGroesser(Ordnungsklasse(pSuchbaum.wurzelInhalt)) then begin
          lRechterTeilbaum:=Suchbaum(pSuchbaum.RechterTeilbaum);
          self.fuegeEinRekursiv(lRechterTeilbaum,pInhalt);
          pSuchbaum.haengeRechtsAn(lRechterTeilbaum);
        end else
              pInhalt.gibFrei; // Inhalt schon vorhanden
  end;

  function Suchbaum.suche(pObjekt:Ordnungsklasse):Ordnungsklasse;
  var
    lBaum:Suchbaum;
  begin
    lBaum:=sucheRekursiv(self,pObjekt);
    if lBaum.istLeer then
      result:=nil
    else
      result:=Ordnungsklasse(lBaum.wurzelInhalt);
  end;


   function Suchbaum.sucheRekursiv(pBaum:Suchbaum;pObjekt:Ordnungsklasse):Suchbaum;
  var
    lLinkerTeilbaum, lRechterTeilbaum:Suchbaum;
  begin
    if not pBaum.istLeer then
       if Ordnungsklasse(pBaum.wurzelInhalt).istGleich(pObjekt) then
          result:=pBaum
      else
        if Ordnungsklasse(pBaum.wurzelInhalt).istKleiner(pObjekt) then begin
          lRechterTeilbaum:=Suchbaum(pBaum.rechterTeilbaum);
          result:=sucheRekursiv(lRechterTeilbaum,pObjekt)
        end else begin
          lLinkerTeilbaum:=Suchbaum(pBaum.linkerTeilbaum);
          result:=sucheRekursiv(lLinkerTeilbaum,pObjekt)
     end else
       result:=pBaum;
  end;


  procedure Suchbaum.entferne(pObjekt:Ordnungsklasse);
  var
   lSuchbaum:Suchbaum;
  begin
    self.entferneRekursiv(self,pObjekt,false);
  end;

  procedure Suchbaum.entferneRekursiv(pBaum:Binaerbaum;pObjekt:Ordnungsklasse;mitInhalt:Wahrheitswert);
  var
    lLinkerTeilbaum, lRechterTeilbaum:Suchbaum;
    lKnoten,lGroessterLinkerKnoten, lVaterGroesster:Binaerbaum;
  begin
    if not pBaum.istLeer then
       if Ordnungsklasse(pBaum.wurzelInhalt).istGleich(pObjekt) then begin
          lKnoten:=pBaum;
          if pBaum.rechterTeilbaum.istLeer then begin
            pBaum.rechterTeilbaum.gibfrei(false);
            lKnoten:=pBaum.linkerTeilbaum;
            pBaum.ueberschreibeWurzel(lknoten.wurzelInhalt);
            pBaum.haengeLinksAn(lKnoten.linkerTeilbaum);
            pBaum.haengeRechtsAn(lKnoten.rechterTeilbaum);
            lKnoten.gibFrei(mitInhalt);
          end else
                if pBaum.linkerTeilbaum.istLeer then begin
                   pBaum.linkerTeilbaum.gibfrei(false);
                   lKnoten:=pBaum.rechterTeilbaum;
                   pBaum.ueberschreibeWurzel(lknoten.wurzelInhalt);
                   pBaum.haengeLinksAn(lKnoten.linkerTeilbaum);
                   pBaum.haengeRechtsAn(lKnoten.rechterTeilbaum);
                   lKnoten.gibFrei(mitInhalt);
                 end else begin
                       lVaterGroesster:=Suchbaum.init;
                       lGroessterLinkerKnoten:=lKnoten.linkerTeilbaum;
                       while not lGroessterLinkerKnoten.rechterTeilbaum.istLeer do begin
                         lVaterGroesster:=lGroessterLinkerKnoten;
                         lGroessterLinkerKnoten:=lGroessterLinkerKnoten.rechterTeilbaum;
                       end;
                       if not lVaterGroesster.istLeer then begin
                         lVaterGroesster.haengeRechtsAn(lGroessterLinkerKnoten.linkerTeilbaum);
                         lGroessterLinkerKnoten.haengeLinksAn(lKnoten.linkerTeilbaum)
                       end;
                       lKnoten.ueberschreibeWurzel(lGroessterLinkerKnoten.wurzelInhalt);
                       lKnoten.haengeLinksAn(lGroessterLinkerKnoten.linkerTeilbaum);
                       lGroessterLinkerKnoten.gibFrei(mitInhalt);
                     end;
        end else
              if Ordnungsklasse(pBaum.wurzelInhalt).istKleiner(pObjekt) then begin
                 lRechterTeilbaum:=Suchbaum(pBaum.rechterTeilbaum);
                 self.entferneRekursiv(lRechterTeilbaum,pObjekt,mitInhalt);
               end else begin
                     lLinkerTeilbaum:=Suchbaum(pBaum.linkerTeilbaum);
                     self.entferneRekursiv(lLinkerTeilbaum,pObjekt,mitInhalt);
                    end;
  end;

 function Suchbaum.sortierteListe:Liste;
  begin
    hatListe:=Liste.init;
    erzeugeListe(self);
    result:=hatListe;
  end;


  procedure Suchbaum.erzeugeListe(pSuchbaum:Suchbaum);
  begin
    if not pSuchbaum.istLeer then begin
       erzeugeListe(Suchbaum(pSuchbaum.linkerTeilbaum));
       hatListe.haengeAn(pSuchbaum.wurzelInhalt);
       erzeugeListe(Suchbaum(pSuchbaum.rechterTeilbaum));
    end;
  end;


  destructor Suchbaum.gibFrei(mitInhalt:Wahrheitswert);
  begin
    inherited gibFrei(mitInhalt);
  end;

end.
